"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import Union

from pydantic import Field

from githubkit.utils import UNSET
from githubkit.typing import Missing
from githubkit.compat import GitHubModel, model_rebuild


class EnterpriseSecurityAnalysisSettings(GitHubModel):
    """Enterprise Security Analysis Settings"""

    advanced_security_enabled_for_new_repositories: bool = Field(
        description="Whether GitHub advanced security is automatically enabled for new repositories and repositories transferred to\nthis enterprise."
    )
    advanced_security_enabled_for_new_user_namespace_repositories: Missing[bool] = (
        Field(
            default=UNSET,
            description="Whether GitHub Advanced Security is automatically enabled for new user namespace repositories.",
        )
    )
    dependabot_alerts_enabled_for_new_repositories: bool = Field(
        description="Whether Dependabot alerts are automatically enabled for new repositories and repositories transferred to this\nenterprise."
    )
    secret_scanning_enabled_for_new_repositories: bool = Field(
        description="Whether secret scanning is automatically enabled for new repositories and repositories transferred to this\nenterprise."
    )
    secret_scanning_push_protection_enabled_for_new_repositories: bool = Field(
        description="Whether secret scanning push protection is automatically enabled for new repositories and repositories\ntransferred to this enterprise."
    )
    secret_scanning_push_protection_custom_link: Missing[Union[str, None]] = Field(
        default=UNSET,
        description="An optional URL string to display to contributors who are blocked from pushing a secret.",
    )
    secret_scanning_validity_checks_enabled: Missing[bool] = Field(
        default=UNSET,
        description="Whether secret scanning automatic validity checks on supported partner tokens is enabled for all repositories under this enterprise.",
    )


model_rebuild(EnterpriseSecurityAnalysisSettings)

__all__ = ("EnterpriseSecurityAnalysisSettings",)
