"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import Literal

from pydantic import Field

from githubkit.compat import GitHubModel, model_rebuild


class RepositoryRuleParamsCodeScanningTool(GitHubModel):
    """CodeScanningTool

    A tool that must provide code scanning results for this rule to pass.
    """

    alerts_threshold: Literal["none", "errors", "errors_and_warnings", "all"] = Field(
        description='The severity level at which code scanning results that raise alerts block a reference update. For more information on alert severity levels, see "[About code scanning alerts](https://docs.github.com/enterprise-cloud@latest//code-security/code-scanning/managing-code-scanning-alerts/about-code-scanning-alerts#about-alert-severity-and-security-severity-levels)."'
    )
    security_alerts_threshold: Literal[
        "none", "critical", "high_or_higher", "medium_or_higher", "all"
    ] = Field(
        description='The severity level at which code scanning results that raise security alerts block a reference update. For more information on security severity levels, see "[About code scanning alerts](https://docs.github.com/enterprise-cloud@latest//code-security/code-scanning/managing-code-scanning-alerts/about-code-scanning-alerts#about-alert-severity-and-security-severity-levels)."'
    )
    tool: str = Field(description="The name of a code scanning tool")


model_rebuild(RepositoryRuleParamsCodeScanningTool)

__all__ = ("RepositoryRuleParamsCodeScanningTool",)
