"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from datetime import datetime
from typing import List, Union

from pydantic import Field

from githubkit.utils import UNSET
from githubkit.typing import Missing
from githubkit.compat import GitHubModel, model_rebuild

from .group_0001 import SimpleUser


class OrganizationRole(GitHubModel):
    """Organization Role

    Organization roles
    """

    id: int = Field(description="The unique identifier of the role.")
    name: str = Field(description="The name of the role.")
    description: Missing[Union[str, None]] = Field(
        default=UNSET,
        description="A short description about who this role is for or what permissions it grants.",
    )
    permissions: List[str] = Field(
        description="A list of permissions included in this role."
    )
    organization: Union[None, SimpleUser] = Field()
    created_at: datetime = Field(description="The date and time the role was created.")
    updated_at: datetime = Field(
        description="The date and time the role was last updated."
    )


class OrgsOrgOrganizationRolesGetResponse200(GitHubModel):
    """OrgsOrgOrganizationRolesGetResponse200"""

    total_count: Missing[int] = Field(
        default=UNSET,
        description="The total number of organization roles available to the organization.",
    )
    roles: Missing[List[OrganizationRole]] = Field(
        default=UNSET,
        description="The list of organization roles available to the organization.",
    )


model_rebuild(OrganizationRole)
model_rebuild(OrgsOrgOrganizationRolesGetResponse200)

__all__ = (
    "OrganizationRole",
    "OrgsOrgOrganizationRolesGetResponse200",
)
