"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from datetime import datetime
from typing import Union, Literal

from pydantic import Field

from githubkit.utils import UNSET
from githubkit.typing import Missing
from githubkit.compat import GitHubModel, model_rebuild

from .group_0001 import SimpleUser
from .group_0005 import Integration


class DeploymentStatus(GitHubModel):
    """Deployment Status

    The status of a deployment.
    """

    url: str = Field()
    id: int = Field()
    node_id: str = Field()
    state: Literal[
        "error", "failure", "inactive", "pending", "success", "queued", "in_progress"
    ] = Field(description="The state of the status.")
    creator: Union[None, SimpleUser] = Field()
    description: str = Field(
        max_length=140, default="", description="A short description of the status."
    )
    environment: Missing[str] = Field(
        default=UNSET,
        description="The environment of the deployment that the status is for.",
    )
    target_url: str = Field(
        default="", description="Deprecated: the URL to associate with this status."
    )
    created_at: datetime = Field()
    updated_at: datetime = Field()
    deployment_url: str = Field()
    repository_url: str = Field()
    environment_url: Missing[str] = Field(
        default=UNSET, description="The URL for accessing your environment."
    )
    log_url: Missing[str] = Field(
        default=UNSET, description="The URL to associate with this status."
    )
    performed_via_github_app: Missing[Union[None, Integration]] = Field(default=UNSET)


model_rebuild(DeploymentStatus)

__all__ = ("DeploymentStatus",)
